{$B-,U-,C-,K-}
Program Stay_Resident;
CONST
   DDSEG: INTEGER = 0;
   maxposterlen = 4096;
   time_out_wait = 540;
type

   Regtype     = record Ax,Bx,Cx,Dx,Bp,Si,Di,Ds,Es,Flags:integer  end;
   WORKSTRING =         STRING [80];
   carrier_type =
      (waiting_for_connect,
      got_connect,
      waiting_for_hangup,
      hungup);
   tick_command_type =
      (hang_up,
      initialize_modem,
      wait_for_caller,
      display_poster,
      wait_for_hangup);
   interrupt_address =  record
                           ipreg:       integer;
                           csreg:       integer;
                        end;

var
   fname:                       workstring;
   pf:                          file of byte;
   acaport:                     integer;
   b:                           byte;
   yn:                          char;
   SaveRegs                      : regtype;
{   real_aca_int:                interrupt_address absolute 0:$30;
}
   isr_com1:                    interrupt_address absolute 0:$30;
   isr_com2:                    interrupt_address absolute 0:$2C;
   real_timer_int:              interrupt_address absolute 0:$70;
   extra_regs:                  regtype;
   orig_timer_int:              interrupt_address;
   orig_aca_int:                interrupt_address absolute 0:$198;
   our_aca_int:                 interrupt_address;
   our_timer_int:               interrupt_address;
   initial_string:              workstring;
   posterlen:                   integer;
   poster:                      array[1..maxposterlen] of char;
   wait_time:                   integer;
   this_char:                   integer;
   aca_buff:                    workstring;
   wait_ticks:                  integer;
   status:                      carrier_type;
   ok:                          boolean;
   tick_command:                tick_command_type;
   portnum: integer;


procedure SDISPLAY(ROW,COL:INTEGER; VAR S:WORKSTRING);
   var i: integer;
   BEGIN;
   for i := 1 to length(s) do begin;
      memw[$b800: row*160+(col+i)*2-164] :=  79 shl 8 + ord(s[i]);
      end;
   end;


PROCEDURE SET_BAUD_RATE(RATE:INTEGER);
   var i: integer;
   BEGIN;
   i := 1152 div (rate div 100);
   PORT[acaport+3] := $83;
   PORT[acaport]   := lo(i);
   PORT[acaport+1] := hi(i);
   PORT[acaport+3] := $03;
   END;


procedure term_ready(s:Boolean);
var x:byte;
begin
  x := port[acaport+4] and $FE;
  if s then x:=x+1;
  port[acaport+4] := x;

end;

var ss: workstring;

procedure send(c:char);
   begin;
   port[acaport] := ord(c);
         ss := c;
         sdisplay(2,this_char,ss);
   end;


procedure timer_handler;
   var i: integer; label exit;
   begin;
   inline ($50/$53/$51/$52/$56/$57/$1E/$06/$FB);
   (* SET DSEG REGISTER *)
   inline ($2e/$a1/ddseg/$8e/$d8);

   str(ord(tick_command):5,ss);
   sdisplay(1,1,ss);
   str(ord(status):5,ss);
   sdisplay(1,20,ss);

   if wait_ticks > 0 then begin;
      wait_ticks := wait_ticks-1;
      goto exit;
      end;

   case tick_command of
hang_up:
         begin;
         set_baud_rate(2400);
         term_ready(false);
         wait_ticks := 2*18;
         this_char := 0;
         tick_command := initialize_modem;
         end;
initialize_modem:
         begin;
         term_ready(true);
         this_char := this_char+1;
         send(initial_string[this_char]);
         if this_char = length(initial_string) then begin;
            status := waiting_for_connect;
            aca_buff := '';
            tick_command := wait_for_caller;
            wait_time := 18*30*60 {wait 30 minutes for caller}
            end;
         end;
wait_for_caller:
         begin;
         if status=got_connect then begin;
            this_char := 0;
            tick_command := display_poster;
            end
         else begin;
            wait_time := wait_time-1;
            if wait_time <= 0 then begin;
               tick_command := hang_up;
               end;
            end;
         end;
display_poster:
         begin;
         this_char := this_char+1;
         send(poster[this_char]);
         ss := poster[this_char];
         sdisplay(2,this_char,ss);
         if this_char >= posterlen then begin;
            aca_buff := '';
            status := waiting_for_hangup;
            tick_command := wait_for_hangup;
            wait_time := time_out_wait;
            end;
         end;
wait_for_hangup:
         begin;
         if status=hungup then begin;
            tick_command := hang_up;
            wait_ticks := 5*18;
            end
         else begin;
            wait_time := wait_time-1;
            if wait_time <= 0 then begin;
               tick_command := hang_up;
               end;
            end;
         end;
      end; {CASE}

exit:
   inline ($07/$1F/$5F/$5E/$5A/$59/$5B/$58/$8B/$E5/$5D/$CF);
   end;


function cdet:boolean;
begin
  cdet:=(port[acaport+6] and 128)<>0;
end;

var sa: workstring;
PROCEDURE ACA_HANDLER;
   VAR B: BYTE;
   BEGIN;
   INLINE ($50/$53/$51/$52/$56/$57/$1E/$06/$FB);
   (* set dseg *)
   inline ($2e/$a1/ddseg/$8e/$d8);
   { get the byte }
   b := PORT[acaport];
   sa := aca_buff+' ';
   sdisplay(1,40,sa);
   if b = 13 then begin;
      if status = waiting_for_connect then begin;
         if aca_buff='1' then begin;
            set_baud_rate(300);
            status := got_connect;
            end
         else if aca_buff='5' then begin;
            set_baud_rate(1200);
            status := got_connect;
            end
         else if aca_buff='10' then begin;
            set_baud_rate(2400);
            status := got_connect;
            end;
         aca_buff := '';
         end
      else if status = waiting_for_hangup then begin;
         if not cdet then status := hungup;
         aca_buff:='';
         end;
      end
   else if b <> 10 then begin;
      aca_buff := aca_buff+chr(b);
      end;
   { clear interrupt }
   PORT[$20] := $20;
   INLINE ($07/$1F/$5F/$5E/$5A/$59/$5B/$58/$8B/$E5/$5D/$CF);
   END;


PROCEDURE ACA_INIT;
   VAR i:integer; B,M: BYTE;
   BEGIN;
   aca_buff := '';
   INLINE ($FA);
   DDSEG := DSEG;
   PORT[acaport+4] := $03;
   PORT[acaport+1] := 1;
   PORT[acaport+4] := $0B;
   SET_BAUD_RATE(2400);
   { enable interrupts }
   PORT[$20] := $20;
   INLINE($FB);
   B := PORT[$21];
   if acaport = $3f8 then m := $ef else  m := $f7;
   PORT[$21] := B AND m;
   { read garbage character in buffer }
   B := PORT[acaport];
   PORT[$20] := $20;
   END;


procedure install_isrs;
   begin;
   DDSEG := DSEG;
   tick_command := hang_up;
   status := hungup;
   wait_ticks := 4*18;
   our_aca_int.ipreg := ofs(aca_handler);
   our_aca_int.csreg := cseg;
   our_timer_int.ipreg := ofs(timer_handler);
   our_timer_int.csreg := cseg;

   inline ($fa);
   orig_timer_int := real_timer_int;
   if acaport=$3f8 then
      isr_com1  := our_aca_int
   else
      isr_com2  := our_aca_int;
   real_timer_int := our_timer_int;
   inline ($fb);
   end;


begin {main}
   writeln('hang_up=',ord(hang_up));
   writeln('hungup =',ord(hungup));
   initial_string := #13+'AT V0 S0=1 X1 E0 '+#13;
   posterlen := 0;
   repeat
      write('Which comm port? ');
      readln(portnum);
   until(portnum in [1,2]);
   if portnum = 1 then acaport := $3f8 else acaport := $2f8;

   repeat begin;
      repeat begin;
         write('Enter the poster filename: ');
         readln(fname);
         assign(pf,fname);
         reset(pf);
         end;
      until(ioresult=0);
      repeat begin;
         read(pf,b);
         if not eof(pf) then begin;
            posterlen := posterlen+1;
            poster[posterlen] := chr(b);
            write(chr(b));
            end;
         end;
      until ((ioresult<>0) or eof(pf) or (posterlen=maxposterlen));
      close(pf);
      write('Is this correct? ');
      readln(yn);
      end;
   until( (yn='Y') and (posterlen>0) );
   set_baud_rate(2400);
   install_isrs;
   aca_init;
   writeln('Nocomm installed');
   SaveRegs.Ax := $31 shl 8 + 0 ;          { Terminate and Stay Resident }
   SaveRegs.Dx := MemW [Cseg-1:0003] ;     { Prog_Size from Allocation Blk}
   Intr ($21,SaveRegs);
end.
